#include <linux/module.h>
#define INCLUDE_VERMAGIC
#include <linux/build-salt.h>
#include <linux/elfnote-lto.h>
#include <linux/vermagic.h>
#include <linux/compiler.h>

BUILD_SALT;
BUILD_LTO_INFO;

MODULE_INFO(vermagic, VERMAGIC_STRING);
MODULE_INFO(name, KBUILD_MODNAME);

__visible struct module __this_module
__section(".gnu.linkonce.this_module") = {
	.name = KBUILD_MODNAME,
	.init = init_module,
#ifdef CONFIG_MODULE_UNLOAD
	.exit = cleanup_module,
#endif
	.arch = MODULE_ARCH_INIT,
};

MODULE_INFO(intree, "Y");

#ifdef CONFIG_RETPOLINE
MODULE_INFO(retpoline, "Y");
#endif

static const struct modversion_info ____versions[]
__used __section("__versions") = {
	{ 0x3444ac2, "module_layout" },
	{ 0xcc512cc4, "dev_attr_phy_event_threshold" },
	{ 0xc98a9d96, "hisi_sas_host_reset" },
	{ 0xe32708d5, "sas_bios_param" },
	{ 0xa79c3d23, "ata_scsi_dma_need_drain" },
	{ 0xff9b399a, "sas_change_queue_depth" },
	{ 0xe983cfbd, "hisi_sas_scan_start" },
	{ 0x200dae13, "hisi_sas_scan_finished" },
	{ 0x76e53cd6, "sas_target_destroy" },
	{ 0xe6a67c1d, "sas_target_alloc" },
	{ 0xee3304a0, "hisi_sas_slave_configure" },
	{ 0x6596160c, "sas_slave_alloc" },
	{ 0x19108030, "sas_eh_target_reset_handler" },
	{ 0x98134109, "sas_eh_device_reset_handler" },
	{ 0x96926433, "sas_ioctl" },
	{ 0x753d79f6, "sas_queuecommand" },
	{ 0xb32578fb, "platform_driver_unregister" },
	{ 0x25cdb7f1, "__platform_driver_register" },
	{ 0xc0ed0ab6, "hisi_sas_init_mem" },
	{ 0x29bd5a44, "hisi_sas_stop_phys" },
	{ 0xe523ad75, "synchronize_irq" },
	{ 0xa15ae263, "platform_get_irq" },
	{ 0x28dc089d, "device_property_read_u32_array" },
	{ 0x1162f2b8, "device_property_present" },
	{ 0xc2a113a, "add_timer" },
	{ 0x2dc6bbdb, "hisi_sas_phy_down" },
	{ 0xa6257a2f, "complete" },
	{ 0x9c5888f9, "hisi_sas_notify_phy_event" },
	{ 0xc5b6f236, "queue_work_on" },
	{ 0x41b3a8ab, "sas_notify_port_event" },
	{ 0xa1daf819, "hisi_sas_phy_oob_ready" },
	{ 0xfa0252eb, "regmap_read" },
	{ 0xe96d6f57, "regmap_write" },
	{ 0xd92deb6b, "acpi_evaluate_object" },
	{ 0xa4c53b8b, "is_acpi_device_node" },
	{ 0xeae3dfd6, "__const_udelay" },
	{ 0x4a3ad70e, "wait_for_completion_timeout" },
	{ 0xe1537255, "__list_del_entry_valid" },
	{ 0x40ac648c, "hisi_sas_get_prog_phy_linkrate_mask" },
	{ 0xf9a482f9, "msleep" },
	{ 0x65a77917, "rt_mutex_base_init" },
	{ 0xdf521442, "_find_next_zero_bit" },
	{ 0x8631c9ba, "alt_cb_patch_nops" },
	{ 0x3cf85989, "mod_timer" },
	{ 0x15ba50a6, "jiffies" },
	{ 0x78534f62, "init_timer_key" },
	{ 0xebfae55c, "hisi_sas_get_ata_protocol" },
	{ 0x40f6d040, "to_hisi_sas_port" },
	{ 0xfbe215e4, "sg_next" },
	{ 0x8dc8e361, "_dev_info" },
	{ 0x1f4eeb5a, "sas_task_abort" },
	{ 0x404728e9, "__dynamic_dev_dbg" },
	{ 0x8875d163, "sas_ssp_task_response" },
	{ 0xc485d232, "_dev_warn" },
	{ 0x4829a47e, "memcpy" },
	{ 0xa6c928cc, "dma_unmap_sg_attrs" },
	{ 0x1313ae76, "hisi_sas_slot_task_free" },
	{ 0x9f15f501, "timer_delete" },
	{ 0xdcb764ad, "memset" },
	{ 0x5bb3d502, "rt_spin_unlock" },
	{ 0x3a31a005, "rt_spin_lock" },
	{ 0x732ffe78, "hisi_sas_sata_done" },
	{ 0x183e1fe8, "devm_request_threaded_irq" },
	{ 0x8da6585d, "__stack_chk_fail" },
	{ 0x94f89a96, "devm_platform_get_irqs_affinity" },
	{ 0x8cd9883d, "hisi_sas_phy_enable" },
	{ 0x923671eb, "_dev_err" },
	{ 0xfa4d3c24, "log_post_write_mmio" },
	{ 0xc905402b, "log_write_mmio" },
	{ 0xc1a5ee3, "log_post_read_mmio" },
	{ 0x6b722180, "log_read_mmio" },
	{ 0x53a1e8d9, "_find_next_bit" },
	{ 0xd6241b27, "irq_get_irq_data" },
	{ 0x17de3d5, "nr_cpu_ids" },
	{ 0xce712a78, "hisi_sas_probe" },
	{ 0x57c97037, "hisi_sas_remove" },
};

MODULE_INFO(depends, "libsas,hisi_sas_main");

MODULE_ALIAS("acpi*:HISI0162:*");
MODULE_ALIAS("of:N*T*Chisilicon,hip06-sas-v2");
MODULE_ALIAS("of:N*T*Chisilicon,hip06-sas-v2C*");
MODULE_ALIAS("of:N*T*Chisilicon,hip07-sas-v2");
MODULE_ALIAS("of:N*T*Chisilicon,hip07-sas-v2C*");

MODULE_INFO(srcversion, "D863D53ECD8F28AC9973E40");
MODULE_INFO(rhelversion, "9.3");
